#pragma once

#include "CoreMinimal.h"
#include "StoreCharactersViewInterface.h"
#include "CoreStoreBaseSubTabsWidget.h"
#include "EPlayerRole.h"
#include "EStoreCharactersMenuState.h"
#include "CoreStoreCharactersWidget.generated.h"

class UDBDTextBlock;
class UCoreStoreCharactersSelectionWidget;
class UCoreStoreCharactersCustomizationsWidget;
class UCoreStoreCharactersBioWidget;
class UToggleableWidgetPromptController;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCoreStoreCharactersWidget : public UCoreStoreBaseSubTabsWidget, public IStoreCharactersViewInterface
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	EPlayerRole _role;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	EStoreCharactersMenuState _currentMenuState;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* SelectedCharacterNameTB;

private:
	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreStoreCharactersSelectionWidget* SelectionTab;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreStoreCharactersCustomizationsWidget* CustomizationsTab;

	UPROPERTY(BlueprintReadWrite, meta=(AllowPrivateAccess=true, BindWidgetOptional))
	UCoreStoreCharactersBioWidget* BioTab;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UToggleableWidgetPromptController* _toggleableWidgetPromptController;

public:
	UFUNCTION(BlueprintCallable)
	void SetToggleableWidgetPromptController(UToggleableWidgetPromptController* controller);

	UFUNCTION(BlueprintPure)
	UToggleableWidgetPromptController* GetToggleableWidgetPromptController() const;

	UFUNCTION(BlueprintPure)
	UCoreStoreCharactersSelectionWidget* GetSelectionTab() const;

	UFUNCTION(BlueprintPure)
	UCoreStoreCharactersCustomizationsWidget* GetCustomizationsTab() const;

	UFUNCTION(BlueprintPure)
	UCoreStoreCharactersBioWidget* GetBioTab() const;

public:
	UCoreStoreCharactersWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreStoreCharactersWidget) { return 0; }
